clear;clc;

seed = 4;
rng(seed);

n = 50000;
k = 12;

fprintf('seed:%d, n:%d, p:%d\n', seed, n, k);

h = 1 / (n + 1);
A = 1 / h^2 * spdiags(ones(n, 1) * [-1 2 -1], [-1 0 1], n, n);    
M = spdiags([rand(n-1, 1); 0] + 0.1, [0], n, n);
% M = speye(n);
LM = chol(M, 'lower');
b = randn(n, 1);
B = [];

% scalar = 0.5 * (b' * b) / (norm(A, 'fro') * norm(M, 'fro'));
% initialX.main = sqrt(scalar) * orth(randn(n, k)); % random initial 
% initialX.main = randn(n, k); % random initial
Y = randn(n, k);
% Y = Y / norm(Y, 'fro');
initialX.main = Y;

norm(Y, 'fro')

% parameters the manifold
ManiParams.name = 'SymFixedRankQ';
ManiParams.n = n;
ManiParams.p = k;
ManiParams.IsCheckParams = 0;
ManiParams.ParamSet = 1;
% 1: Euclidean metric on S_+(p,n); vector transport by parallelization
% 4: Euclidean metric on S_+(p,n); vector transport by projection
% 2: second metric; vector transport by parallelization
% 5: second metric; vector transport by projection
% 3: third metric; vector transport by parallelization
% 6: third metric; vector transport by projection
HasHHR = 0;

% common parameters for different solvers
SolverParams.IsCheckParams = 0;
SolverParams.DEBUG = 2;
SolverParams.Min_Iteration = 1;
SolverParams.Max_Iteration = 500;
SolverParams.OutputGap = 1;
SolverParams.Tolerance = 1e-11;
SolverParams.Accuracy = 1e-12;
SolverParams.Max_Inner_Iter = 1000;
SolverParams.IsCheckGradHess = 0;

% test
preconditioner = 1;

method = 'RNewton';
% method = 'RTRNewton';
% SolverParams.initial_Delta = 1e15;       % TR-type
% SolverParams.maximum_Delta = 1e15; % TR-type

fprintf('DriverMexProb_SymFixedRankQ, precond:%d\n', preconditioner);

SolverParams.method = method;
SolverParams.Num_pre_funs = 0;


[FinalX, fv, gfv, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, eigHess] = ...
LyapunovLR_(A, M, LM, B, b, n, k, ManiParams, SolverParams, HasHHR, initialX, preconditioner);
FinalX.approx_res
% preconditioner = 4;
% [FinalX, fv, gfv, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, eigHess] = ...
% LyapunovLR_(A, M, LM, B, b, n, k, ManiParams, SolverParams, HasHHR, initialX, preconditioner);
