
#include "test/TestSFRELyap.h"

using namespace ROPTLIB;

void testSFREQuadratic(void)
{
    // size of the domain
    integer n = 250, p = 3;
    Vector A(n, n), M(n, n), b(n, 1);
    A.RandGaussian();
    M.RandGaussian();
    b.RandGaussian();
    A = A * A.GetTranspose();
    M = M * M.GetTranspose();
    // Obtain an initial iterate
//    Variable EucX(dim, 1);
//    EucX.RandInManifold();
    SymFixedRankE Domain(n, p);
    Variable EucX = Domain.RandominManifold();
    
//    Vector Vx(n, p), Dx(p, p);
//
//    SymFixedRankE::extractSubMatrix(EucX, 0, Vx);
//    SymFixedRankE::extractSubMatrix(EucX, n*p, Dx);
//    (Vx.GetTranspose() * Vx).Print();
//    Dx.Print();
    
    // Define the problem
    SFRELyap Prob(A, M, b, n, p);
    Prob.SetDomain(&Domain);
//    Prob.CheckGradHessian(EucX);       
            
//    A.EigenDecomSym();
//    A.Field("_EigVal").Print("eigs:");
    
    /*Domain.CheckRetraction(EucX);
    Domain.CheckVecTranDiffRet(EucX, true);
    Domain.CheckLockingCondition(EucX);
    Domain.CheckVecTranDiffRetAdjoint(EucX);
    Domain.CheckIsometryofVectorTransport(EucX);
    Domain.CheckIsometryofInvVectorTransport(EucX);
    Domain.CheckVecTranComposeInverseVecTran(EucX);
    Domain.CheckTranHInvTran(EucX);
    Domain.CheckHaddScaledRank1OPE(EucX);*/
    
    Prob.CheckGradHessian(EucX);
    
    
//    LRTRSR1woR *LRTRSR1woRsolver = new LRTRSR1woR(&Prob, &EucX);
//    LRTRSR1woRsolver->Verbose = ITERRESULT;//--- FINALRESULT;
//    LRTRSR1woRsolver->Max_Iteration = 1000;
//    LRTRSR1woRsolver->initial_Delta = 1e-2;
//    LRTRSR1woRsolver->OutputGap = 100;
//    LRTRSR1woRsolver->LMrestart = false;
//    LRTRSR1woRsolver->LengthSY = 1;
//    LRTRSR1woRsolver->CheckParams();
//    LRTRSR1woRsolver->Run();
//    delete LRTRSR1woRsolver;
    
    RNewton *Solver = new RNewton(&Prob, &EucX);
//    RTRNewton *Solver = new RTRNewton(&Prob, &EucX);
//    RSD *Solver = new RSD(&Prob, &EucX);
    Solver->Verbose = ITERRESULT;
    Solver->Max_Iteration = 600;
    Solver->Max_Inner_Iter = 500;
    Solver->Accuracy = 1e-8;
    Solver->Tolerance = 1e-10;
//    Solver->InitSteptype
//    Solver->Initstepsize = 1.;
//    Solver->InitSteptype = LSSM_ONESTEP;
//    Solver->InitSteptype = LSSM_BBSTEP;
//    Solver->Num_pre_funs = 5;
//    Solver->minimum_Delta = 1e2;
//    Solver->maximum_Delta = 1e8;
    Solver->OutputGap = 1;
    
    Solver->CheckParams();
    Solver->Run();
    delete Solver;
    
    
//    LRTRSR1woR *LRTRSR1woRsolver2 = new LRTRSR1woR(&Prob, &EucX);
//    LRTRSR1woRsolver2->Verbose = ITERRESULT;//--- FINALRESULT;
//    LRTRSR1woRsolver2->Max_Iteration = 1000;
//    LRTRSR1woRsolver2->initial_Delta = 1e-2;
//    LRTRSR1woRsolver2->OutputGap = 100;
//    LRTRSR1woRsolver2->LMrestart = false;
//    LRTRSR1woRsolver2->LengthSY = 4;
//    LRTRSR1woRsolver2->CheckParams();
//    LRTRSR1woRsolver2->Run();
//    delete LRTRSR1woRsolver2;

//    LRBFGS *LRBFGSsolver = new LRBFGS(&Prob, &EucX);
//    LRBFGSsolver->Verbose = ITERRESULT;//--- FINALRESULT;
//    LRBFGSsolver->Max_Iteration = 20;
//    LRBFGSsolver->OutputGap = 1;
//    LRBFGSsolver->InitSteptype = LSSM_ONESTEP;
//    LRBFGSsolver->LS_ratio1 = 0.25;
//    LRBFGSsolver->LS_ratio2 = 0.25;
////    LRBFGSsolver->Num_pre_funs = 1000;
//    LRBFGSsolver->LengthSY = 10;
////    LRBFGSsolver->CheckParams();
//    LRBFGSsolver->Run();
//    delete LRBFGSsolver;
//
//    LRTRSR1 *LRTRSR1solver = new LRTRSR1(&Prob, &EucX);
//    LRTRSR1solver->Verbose = ITERRESULT;//--- FINALRESULT;
//    LRTRSR1solver->Max_Iteration = 1000;
////    LRTRSR1solver->LengthSY  = 10;
//    LRTRSR1solver->OutputGap = 1;
//    LRTRSR1solver->CheckParams();
//    LRTRSR1solver->Run();
//    delete LRTRSR1solver;

};

//#ifdef MATLAB_MEX_FILE
//
//std::map<integer *, integer> *CheckMemoryDeleted;
//
//void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
//{
//    if(nrhs < 4)
//    {
//        mexErrMsgTxt("The number of arguments should be at least four.\n");
//    }
//    
//    realdp *B, *X;
//    B = mxGetPr(prhs[0]);
//    X = mxGetPr(prhs[1]);
//    /* dimensions of input matrices */
//    integer n, HasHHR;
//    n = mxGetM(prhs[0]);
//    
//    /*Check the correctness of the inputs*/
//    if(mxGetN(prhs[0]) != n)
//    {
//        mexErrMsgTxt("The size of matrix B is not correct.\n");
//    }
//    if(mxGetM(prhs[1]) != n || mxGetN(prhs[1]) != 1)
//    {
//        mexErrMsgTxt("The size of the initial X is not correct!\n");
//    }
//    HasHHR = static_cast<integer> (mxGetScalar(prhs[2]));
//
//    genrandseed(0);
//
//    CheckMemoryDeleted = new std::map<integer *, integer>;
//    //    testStieBrockett(B, D, n, p, X, Xopt);
//
//    // Define the manifold
//    Euclidean Domain(n);
//    Variable initX = Domain.RandominManifold();
//    realdp *initXptr = initX.ObtainWriteEntireData();
//    for(integer i = 0; i < n; i++)
//        initXptr[i] = X[i];
//
//    Vector BB(n, n);
//    realdp *BBptr = BB.ObtainWriteEntireData();
//    for(integer i = 0; i < n * n; i++)
//        BBptr[i] = B[i];
//    // Define the Brockett problem
//    EucQuadratic Prob(BB);
//    Prob.SetDomain(&Domain);
//
//    Domain.SetHasHHR(HasHHR != 0);
//
//    // Call the function defined in DriverMexProb.h
//    ParseSolverParamsAndOptimizing(prhs[3], &Prob, &initX, plhs);
//
//    std::map<integer *, integer>::iterator iter = CheckMemoryDeleted->begin();
//    for (iter = CheckMemoryDeleted->begin(); iter != CheckMemoryDeleted->end(); iter++)
//    {
//        if (iter->second != 1)
//            printf("Global address: %p, sharedtimes: %d\n", iter->first, iter->second);
//    }
//    delete CheckMemoryDeleted;
//    return;
//}
//
//#endif
